From 75e91fe550de225fea6395bc3b801bae0335fdb5 Mon Sep 17 00:00:00 2001
From: Daiki Ueno <ueno@unixuser.org>
Date: Tue, 31 Jan 2012 10:45:18 +0900
Subject: [PATCH 2/3] Generate vapi from gir instead of gi.

---
 bindings/vala/IBus-1.0-custom.vala        |    9 +
 bindings/vala/IBus-1.0.metadata           |    1 +
 bindings/vala/Makefile.am                 |   29 +-
 bindings/vala/ibus-1.0.vapi               | 4928 ----------------------------
 bindings/vala/ibus-1.0/ibus-1.0.defines   |    1 -
 bindings/vala/ibus-1.0/ibus-1.0.excludes  |    5 -
 bindings/vala/ibus-1.0/ibus-1.0.files     |    2 -
 bindings/vala/ibus-1.0/ibus-1.0.gi        | 4994 -----------------------------
 bindings/vala/ibus-1.0/ibus-1.0.metadata  |   13 -
 bindings/vala/ibus-1.0/ibus-1.0.namespace |    1 -
 configure.ac                              |    3 +
 11 files changed, 33 insertions(+), 9953 deletions(-)
 create mode 100644 bindings/vala/IBus-1.0-custom.vala
 create mode 100644 bindings/vala/IBus-1.0.metadata
 delete mode 100644 bindings/vala/ibus-1.0.vapi
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0-custom.vala
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.defines
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.excludes
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.files
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.gi
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.metadata
 delete mode 100644 bindings/vala/ibus-1.0/ibus-1.0.namespace

diff --git a/bindings/vala/IBus-1.0-custom.vala b/bindings/vala/IBus-1.0-custom.vala
new file mode 100644
index 0000000..144d75e
--- /dev/null
+++ b/bindings/vala/IBus-1.0-custom.vala
@@ -0,0 +1,9 @@
+namespace IBus {
+	// For some reason, ibus_text_new_from_static_string is hidden in GIR
+	// https://github.com/ibus/ibus/commit/37e6e587
+	[CCode (type_id = "ibus_text_get_type ()", cheader_filename = "ibus.h")]
+	public class Text : IBus.Serializable {
+		[CCode (cname = "ibus_text_new_from_static_string", has_construct_function = false)]
+		public Text.from_static_string (string str);
+	}
+}
diff --git a/bindings/vala/IBus-1.0.metadata b/bindings/vala/IBus-1.0.metadata
new file mode 100644
index 0000000..79158d0
--- /dev/null
+++ b/bindings/vala/IBus-1.0.metadata
@@ -0,0 +1 @@
+IBus cheader_filename="ibus.h"
diff --git a/bindings/vala/Makefile.am b/bindings/vala/Makefile.am
index 14bd2ba..3492a4a 100644
--- a/bindings/vala/Makefile.am
+++ b/bindings/vala/Makefile.am
@@ -26,15 +26,26 @@ dist_vapi_DATA = \
 	ibus-@IBUS_API_VERSION@.deps \
 	$(NULL)
 
-ibus-@IBUS_API_VERSION@.vapi:
-	vapigen --library=ibus-@IBUS_API_VERSION@ \
-			--pkg=glib-2.0 \
-			--pkg=gio-2.0 \
-			--metadatadir=ibus-@IBUS_API_VERSION@ \
-			ibus-@IBUS_API_VERSION@/ibus-@IBUS_API_VERSION@.gi \
-			ibus-@IBUS_API_VERSION@/ibus-@IBUS_API_VERSION@-custom.vala
+# don't rebuild vapi every time gir is updated
+vapi_deps = \
+	$(srcdir)/IBus-1.0.metadata \
+	$(srcdir)/IBus-1.0-custom.vala \
+	| \
+	$(top_srcdir)/src/IBus-@IBUS_API_VERSION@.gir \
+	$(NULL)
+
+ibus-@IBUS_API_VERSION@.vapi: $(vapi_deps)
+	$(AM_V_GEN) $(VAPIGEN) --library ibus-@IBUS_API_VERSION@ \
+			--pkg gio-2.0 \
+			--metadatadir=$(srcdir) \
+			$(top_srcdir)/src/IBus-@IBUS_API_VERSION@.gir \
+			$(srcdir)/IBus-1.0-custom.vala
+
+EXTRA_DIST = \
+	IBus-1.0.metadata \
+	IBus-1.0-custom.vala \
+	$(NULL)
 
-generate-vala:
-	vala-gen-introspect ibus-@IBUS_API_VERSION@ ibus-@IBUS_API_VERSION@
+MAINTAINERCLEANFILES = ibus-@IBUS_API_VERSION@.vapi
 
 -include $(top_srcdir)/git.mk
diff --git a/configure.ac b/configure.ac
index 74f6d93..0e05b31 100644
--- a/configure.ac
+++ b/configure.ac
@@ -172,6 +172,9 @@ AC_ARG_ENABLE(vala,
     [enable_vala=$enableval],
     [enable_vala=yes]
 )
+if test x"$enable_vala" = x"yes"; then
+    AC_PATH_PROG([VAPIGEN], [vapigen], [false])
+fi
 AM_CONDITIONAL([ENABLE_VALA], [test x"$enable_vala" = x"yes"])
 if test x"$enable_vala" != x"yes"; then
     enable_vala="no (disabled, use --enable-vala to enable)"
-- 
1.7.7.6

